#pragma once

#include "exception.h"

class BCHDecoder
{
public:
    BCHDecoder ()
    {
    }
    //PREV VERSION:
    //bool Decode (bool in_data[], bool out_data[], int size, int sizeOfData)
    //{
    //    if (sizeOfData < 1 && size < sizeOfData)
    //        throw new ExceptionInvalidParam ("Param sizeOfData is invalid");

    //    for (int i = 0; i < sizeOfData; i++)
    //        out_data[i] = in_data[i];
    //    return true;
    //}
    typedef std::vector<std::vector<bool>> vecvec_t;

    std::vector<bool> Xor2VecBool (std::vector<bool>& vec1, std::vector<bool>& vec2)
    {
        if (vec1.size() != vec2.size())
            throw new ExceptionFatalError ("Param vec1.size() != vec2.size()");
        std::vector<bool> bret (vec1.size());
        for (int i = 0; i < (int) vec1.size(); i++)
            bret[i] = vec1[i] ^ vec2[i];
        return bret;
    }
    class GaloisItems
    {
        int m_period;
        int m_power;
        vecvec_t m_vecvecItems;
        std::vector<bool> GetNormIrediciblePolynome (int maxN)
        {
            if (maxN != 4)
                throw new ExceptionUnsupported ("Param maxN != 4 is not supported");

            std::vector<bool> vecOut (maxN+1);
            vecOut[0] = true;
            vecOut[1] = true;
            vecOut[4] = true;
            return vecOut;
        }
    public:
        GaloisItems (int GFparam)
        {
            m_period = GFparam-1;

            int prime;
            if (GFparam == 16)
            {
                prime = 2;
                m_power = 4;
            }
            else
                throw new ExceptionUnsupported ("Param inValue != 16 is not supported");

            m_vecvecItems.resize (GFparam-1);
            for (int i = 0; i < power; i++)
            {
                m_vecvecItems[i].resize (m_power);
                m_vecvecItems[i][i] = true;
            }
            std::vector<bool> vecPolynome = GetNormIrediciblePolynome (m_power);
            std::vector<bool> vecItem = vecPolynome;
            vecItem.resize (m_power);
            m_vecvecItems[m_power] = vecItem;
            for (int i = power+1; i < GFparam-1; i++)
            {
                std::vector<bool> prevAlpha = m_vecvecItems[i-1];
                std::vector<bool> result (m_power);
                for (int j = 0; j < power; j++)
                {
                    if (prevAlpha[j])
                        result = Xor2VecBool (result, m_vecvecItems[j+1]);
                }
                m_vecvecItems[i] = result;
            }
        }
        int GetPower ()
        {
            return m_power;
        }
        std::vector<bool> GetItem (int index)
        {
            index %= m_period;
            return m_vecvecItems[index];
        }
    };

    std::vector<bool> GetSyndromeN (GaloisItems& items, int n, std::vector<bool>& data)
    {
        std::vector vecOut (items.GetPower ());
        for (int i = 0; i < data.size(); i++)
        {
            if (! data[i])
                continue;
            vecOut = Xor2VecBool (items.GetItem (n*i), vecOut);
        }
        return vecOut;
    }
    bool Decode (bool in_data[], bool out_data[], int size, int sizeOfData)
    {
        if (sizeOfData < 1 && size < sizeOfData)
            throw new ExceptionInvalidParam ("Param sizeOfData is invalid");

        GaloisItems items (size+1);
        std::vector<bool> vec = items.GetItem (5);

        return true;
    }

};