#pragma once
#include <string>
#include "vec2n.h"
#include "bmpimg.h"

//Error Codes


class BMP
{
public:
	//Constructor, destructor
	BMP();
	~BMP();

	//Loads a bitmap from file
	BMPErr LoadFromFile (std::string fPath);

	//Returns image's width
	unsigned long GetWidth();

	//Returns image's height
	unsigned long GetHeight();

	//Clears image data
	void Clear();

    bool IsPixelBlack (Vec2n pos);
	
private:
    BMPImg* m_img;
};