#pragma once

#include "qrcode.h"

class CodewordBitstream
{
    QRCode m_qrcode;
    int m_posX, m_posY;
    bool m_isEmpty;
    bool m_upwards;
public:
    // mat - musi byt inicializovana!
    CodewordBitstream (QRCode& qrcode)
    {
        m_qrcode = qrcode;
        m_posX = m_qrcode.GetSize().x()-1;
        m_posY = m_qrcode.GetSize().y()-1;
        m_upwards = true;
        m_isEmpty = false;
    }
private:
    bool IsDataPos (int x, int y)
    {
        return m_qrcode.IsCodewordModule (x, y);
    }

    void NextPossibleBit ()
    {
        if (m_isEmpty)
            return;

        if (m_posX > 6)
        {
            if (m_posX & 1)
            {
                m_posX++;
                if (m_upwards)
                    m_posY--;
                else
                    m_posY++;
            }
            else
            {
                m_posX--;
            }
        }
        else
        {
            if (m_posX & 1)
                m_posX--;
            else
            {
                if (m_upwards)
                    m_posY--;
                else
                    m_posY++;
                m_posX++;
            }
        }
        if (m_posY < 0)
        {
            m_posY++;
            m_posX -= 2;
            m_upwards=false;
            if (m_posX==6)
                m_posX--;
        }
        else if (m_posY >= m_qrcode.GetSize().y())
        {
            m_posY--;
            m_posX -= 2;
            m_upwards=true;
            if (m_posX==6)
                m_posX--;
        }


        if (m_posX < 0)
            m_isEmpty=true;
        
    }
public:
    void NextBit ()
    {
        NextPossibleBit ();
        while (! IsDataPos (m_posX, m_posY))
        {
            if (m_isEmpty)
                break;
            NextPossibleBit ();
        }             
    }

    bool IsEmpty ()
    {
        return m_isEmpty;
    }

    int GetPosX ()
    {
        return m_posX;
    }

    int GetPosY ()
    {
        return m_posY;
    }

    bool GetBit ()
    {
        return m_qrcode.GetValue (GetPosX(), GetPosY());
    }

    unsigned char GetCodewordAndMoveToNext ()
    {
        unsigned char byte = 0;
        for (int i = 0; i < 8; i++)
        {
            if (IsEmpty ())
                throw new ExceptionFatalError ("Out of stream");
            byte = (byte << 1) | ((unsigned char) GetBit ());
            NextBit ();
        }
        return byte;
    }
};
