#pragma once

#include <exception>

#include "base.h"



class Exception: public std::exception
{
public:
    Exception () 
    { }
    Exception (CSTR msg): std::exception (msg) 
    { }
    Exception (Exception& ex): std::exception (ex)
    { }
};

class ExceptionOutOfBuffer: public Exception
{
public:
    ExceptionOutOfBuffer (CSTR msg): Exception (msg)
    { }
    ExceptionOutOfBuffer (ExceptionOutOfBuffer& ex): Exception (ex)
    { }
};

class ExceptionFileNotFound: public Exception
{
public:
    ExceptionFileNotFound (CSTR msg): Exception (msg)
    { }
    ExceptionFileNotFound (ExceptionFileNotFound& ex): Exception (ex)
    { }
};

class ExceptionUnsupported: public Exception
{
public:
    ExceptionUnsupported (CSTR msg): Exception (msg)
    { }
    ExceptionUnsupported (ExceptionUnsupported& ex): Exception (ex)
    { }
};




class ExceptionInvalidParam: public Exception
{
public: 
    ExceptionInvalidParam (CSTR msg): Exception (msg)
    {
    }
};


class ExceptionFatalError: public Exception
{
public:
    ExceptionFatalError (CSTR msg): Exception (msg)
    {
    }
};
