#pragma once

#include "staticdata.h"

class Factory
{
private:
    static StaticData* s_pstaticData;
public:
    StaticData* GetStaticData ()
    {
        if (! s_pstaticData)
            throw new ExceptionFatalError ("QRLib is not initialized");
        return s_pstaticData;
    }
    static void InitFactory (CSTR pathToData)
    {
        if (! s_pstaticData)
            s_pstaticData = new StaticData (pathToData);
        else 
            throw new ExceptionFatalError ("QRLib is initialized, it can not be initialized twice.");
    }
    static void DestroyFactory ()
    {
        delete s_pstaticData;
        s_pstaticData = NULL;
    }
};