#include "qrcode.h"
#include "codewordbitstream.h"


void QRCode::PrintOrderOfCodewords ()
{
    Validate ();

    Matrix<char> matC;
    matC.Recreate (GetSize ());
    for (int y = 0; y < GetSize().y(); y++)
    {
        for (int x = 0; x < GetSize().x(); x++)
        {
            char c = IsCodewordModule (x, y) ? '.' : '?';
            matC.SetValue (Vec2n(x,y), c);
        }
    }
    int count = 0;
    CodewordBitstream stream (*this);
    while (! stream.IsEmpty ())
    {
        char c = '0' + ((count>>3) % 10);
        matC.SetValue (Vec2n(stream.GetPosX(),stream.GetPosY()), c);
        
        count++;
        stream.NextBit ();
    }
    for (int y = 0; y < GetSize().y(); y++)
    {
        for (int x = 0; x < GetSize().x(); x++)
        {
            printf ("%c", matC.GetValue (Vec2n(x,y)));
        }
        printf ("\n"); 
    }
    printf ("\n"); 
}

void QRCode::PrintOrderOfBits ()
{
    Validate ();

    Matrix<char> matC;
    matC.Recreate (GetSize ());
    for (int y = 0; y < GetSize().y(); y++)
    {
        for (int x = 0; x < GetSize().x(); x++)
        {
            char c = IsCodewordModule (x, y) ? '.' : '?';
            matC.SetValue (Vec2n(x,y), c);
        }
    }
    int count = 0;
    CodewordBitstream stream (*this);
    while (! stream.IsEmpty ())
    {
        char c = '0' + ((count) % 10);
        matC.SetValue (Vec2n(stream.GetPosX(),stream.GetPosY()), c);
        
        count++;
        stream.NextBit ();
    }
    for (int y = 0; y < GetSize().y(); y++)
    {
        for (int x = 0; x < GetSize().x(); x++)
        {
            printf ("%c", matC.GetValue (Vec2n(x,y)));
        }
        printf ("\n"); 
    }
    printf ("\n"); 
}